JUCE: DragAndDropTarget Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Member Functions | List of all members
DragAndDropTarget Class Referenceabstract
juce_gui_basics » mouse

Components derived from this class can have things dropped onto them by a DragAndDropContainer. More...

`#include <juce_DragAndDropTarget.h>`

Inheritance diagram for DragAndDropTarget:

## Classes
class | SourceDetails
| Contains details about the source of a drag-and-drop operation. More...

## Public Member Functions
virtual | ~DragAndDropTarget ()=default
| Destructor.
virtual bool | isInterestedInDragSource (const SourceDetails &dragSourceDetails)=0
| Callback to check whether this target is interested in the type of object being dragged.
virtual void | itemDragEnter (const SourceDetails &dragSourceDetails)
| Callback to indicate that something is being dragged over this component.
virtual void | itemDragMove (const SourceDetails &dragSourceDetails)
| Callback to indicate that the user is dragging something over this component.
virtual void | itemDragExit (const SourceDetails &dragSourceDetails)
| Callback to indicate that something has been dragged off the edge of this component.
virtual void | itemDropped (const SourceDetails &dragSourceDetails)=0
| Callback to indicate that the user has dropped something onto this component.
virtual bool | shouldDrawDragImageWhenOver ()
| Overriding this allows the target to tell the drag container whether to draw the drag image while the cursor is over it.

## Detailed Description

Components derived from this class can have things dropped onto them by a DragAndDropContainer.

To create a component that can receive things drag-and-dropped by a DragAndDropContainer, derive your component from this class, and make sure that it is somewhere inside a DragAndDropContainer component.

Note: If all that you need to do is to respond to files being drag-and-dropped from the operating system onto your component, you don't need any of these classes: instead see the FileDragAndDropTarget class.

See also
  DragAndDropContainer, FileDragAndDropTarget

## Constructor & Destructor Documentation

## ◆ ~DragAndDropTarget()

virtual DragAndDropTarget::~DragAndDropTarget | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ isInterestedInDragSource()

virtual bool DragAndDropTarget::isInterestedInDragSource | ( | const SourceDetails & | dragSourceDetails | ) |
| pure virtual

Callback to check whether this target is interested in the type of object being dragged.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Returns
  true if this component wants to receive the other callbacks regarding this type of object; if it returns false, no other callbacks will be made.

Implemented in Toolbar, and TreeView.

## ◆ itemDragEnter()

virtual void DragAndDropTarget::itemDragEnter | ( | const SourceDetails & | dragSourceDetails | ) |
| virtual

Callback to indicate that something is being dragged over this component.

This gets called when the user moves the mouse into this component while dragging something.

Use this callback as a trigger to make your component repaint itself to give the user feedback about whether the item can be dropped here or not.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

See also
  itemDragExit

Reimplemented in TreeView.

## ◆ itemDragMove()

virtual void DragAndDropTarget::itemDragMove | ( | const SourceDetails & | dragSourceDetails | ) |
| virtual

Callback to indicate that the user is dragging something over this component.

This gets called when the user moves the mouse over this component while dragging something. Normally overriding itemDragEnter() and itemDragExit() are enough, but this lets you know what happens in-between.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Reimplemented in Toolbar, and TreeView.

## ◆ itemDragExit()

virtual void DragAndDropTarget::itemDragExit | ( | const SourceDetails & | dragSourceDetails | ) |
| virtual

Callback to indicate that something has been dragged off the edge of this component.

This gets called when the user moves the mouse out of this component while dragging something.

If you've used itemDragEnter() to repaint your component and give feedback, use this as a signal to repaint it in its normal state.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

See also
  itemDragEnter

Reimplemented in Toolbar, and TreeView.

## ◆ itemDropped()

virtual void DragAndDropTarget::itemDropped | ( | const SourceDetails & | dragSourceDetails | ) |
| pure virtual

Callback to indicate that the user has dropped something onto this component.

When the user drops an item this get called, and you can use the description to work out whether your object wants to deal with it or not.

Note that after this is called, the itemDragExit method may not be called, so you should clean up in here if there's anything you need to do when the drag finishes.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Implemented in Toolbar, and TreeView.

## ◆ shouldDrawDragImageWhenOver()

virtual bool DragAndDropTarget::shouldDrawDragImageWhenOver | ( |  | ) |
| virtual

Overriding this allows the target to tell the drag container whether to draw the drag image while the cursor is over it.

By default it returns true, but if you return false, then the normal drag image will not be shown when the cursor is over this target.

The documentation for this class was generated from the following file:

- juce_DragAndDropTarget.h